<?PHP

/* ====================
Land Down Under / Seditio - Website engine
Copyright Neocrome
http://www.neocrome.net

[BEGIN_LDU]
File=plugins/extended/birthdays/birthdays.functions.php
Version=800
Updated=2006-nov-30
Type=Plugin
Author=Poncha
Description=Birthdays plugin - functions
[END_LDU]

[BEGIN_LDU_EXTPLUGIN]
Code=birthdays
Part=functions
File=birthdays.functions
Hooks=plugin.birthdays.functions
Tags=
Minlevel=0
Order=10
[END_LDU_EXTPLUGIN]

[BEGIN_SED]
File=plugins/birthdays/birthdays.functions.php
Version=100
Updated=2006-nov-30
Type=Plugin
Author=Poncha
Description=Birthdays plugin - functions
[END_SED]

[BEGIN_SED_EXTPLUGIN]
Code=birthdays
Part=functions
File=birthdays.functions
Hooks=plugin.birthdays.functions
Tags=
Minlevel=0
Order=10
[END_SED_EXTPLUGIN]

==================== */

if (!defined('LDU_CODE') && !defined('SED_CODE')) { die('Wrong URL.'); }
if (!defined('PLX_CODE')) return false; // PluginLib extension required!

if(defined("PLX_BIRTHDAYS_FUNCTIONS")) return true;
define("PLX_BIRTHDAYS_FUNCTIONS", true);

function birthdays_update()
{
	global $sys, $cfg, $_PLUGINLIB;
	global $db_users, $db_plugin, $db_events;
	global $plx_sql_query, $plx_sql_numrows, $plx_sql_fetchassoc, $plx_sql_freeresult;
	global $plx_cache_clear;

	$sql = <<<SQL
SELECT u.user_id, u.user_birthdate AS u_stamp, b.user_birthdate AS b_stamp, b.event_id, b.event_time, b.news_id, b.news_time
	FROM `{$db_users}` u
		LEFT JOIN `{$db_plugin}` b USING(user_id)
	WHERE b.user_id IS NULL
		OR u.user_birthdate != b.user_birthdate
SQL;
	$res = $plx_sql_query($sql);
	$updates = Array();
	if($plx_sql_numrows($res))
	{
		while($row = $plx_sql_fetchassoc($res))
		{
			if($row["b_stamp"] === null) $sql_type = "INSERT"; // no record in plugin table!
			else $sql_type = "REPLACE"; // updated birthday timestamp

			$row["b_stamp"] = $row["u_stamp"]==0?0:date("Y-m-d", $row["u_stamp"]);
			$sql = <<<SQL
{$sql_type} INTO `{$db_plugin}`
	SET `user_id`='{$row["user_id"]}',
		`user_birthdate`='{$row["u_stamp"]}',
		`user_birth_date`='{$row["b_stamp"]}'
SQL;
			$plx_sql_query($sql);

			$updates[$row["user_id"]] = $row;
		}

		// if updates were made to plugin table, we will have to rebuild the cache
		$plx_cache_clear("birthdays_today");

		if($cfg['plugin']['birthdays']['birthday_events'] && !empty($db_events))
		{
			$user_ids_list = implode(",", array_keys($updates));
			$sql = <<<SQL
UPDATE `{$db_plugin}`
	SET `event_id`=0,
		`event_time`='0'
	WHERE `user_id` IN ({$user_ids_list})
SQL;
			$plx_sql_query($sql);

			$event_ids = Array();
			foreach($updates as $row)
			{
				if(!$row["u_stamp"] || !$row["event_id"] || strtotime($row["event_time"]) < time()) continue;
				$event_ids[] = $row["event_id"];
			}
			if(count($event_ids))
			{
				$event_ids_list = implode(",", $event_ids);
				$sql = <<<SQL
DELETE FROM `{$db_events}`
	WHERE `event_id` IN ({$event_ids_list})
SQL;
				$plx_sql_query($sql);
			}
		}
	}
	$plx_sql_freeresult($res);

	birthdays_update_events();
	birthdays_update_news();

	return count($updates);
}

function birthdays_update_events()
{
	global $sys, $cfg, $_PLUGINLIB;
	global $db_users, $db_groups, $db_plugin, $db_events, $plugin_templates;
	global $plx_sql_query, $plx_sql_numrows, $plx_sql_fetchassoc, $plx_sql_freeresult, $plx_sql_prep, $plx_sql_insertid;

	if(!$cfg['plugin']['birthdays']['birthday_events'] || empty($db_events)) return false;

	$engine = $_PLUGINLIB["engine"];
	switch($engine)
	{
		case "sed":
			$sql = <<<SQL
SELECT u.user_id, u.user_name, u.user_gender, g.grp_level AS user_level, b.user_birth_date, b.event_id, b.event_time
	FROM `{$db_users}` u
		INNER JOIN `{$db_plugin}` b USING(user_id)
		INNER JOIN `{$db_groups}` g ON (u.user_maingrp=g.grp_id)
	WHERE g.grp_level>='{$cfg["plugin"]["birthdays"]["birthday_events_minlevel"]}'
		AND u.user_birthdate!=0
		AND DATE(b.event_time)<DATE(NOW())
SQL;
			break;
		case "ldu":
			$sql = <<<SQL
SELECT u.user_id, u.user_name, u.user_gender, u.user_level, b.user_birth_date, b.event_id, b.event_time
	FROM `{$db_users}` u
		INNER JOIN `{$db_plugin}` b USING(user_id)
	WHERE u.user_level>='{$cfg["plugin"]["birthdays"]["birthday_events_minlevel"]}'
		AND u.user_birthdate!=0
		AND DATE(b.event_time)<DATE(NOW())
SQL;
			break;
		default:
			return false;
	}
	$res = $plx_sql_query($sql);
	while($row = $plx_sql_fetchassoc($res))
	{
		if($engine=="sed")
		{
			$event_owner_fieldname = "event_ownerid";
			$event_owner_fieldvalue = $row["user_id"];
		}
		else
		{
			$event_owner_fieldname = "event_owner";
			$event_owner_fieldvalue = $plx_sql_prep($row["user_name"]);
		}

		$birth_date = explode("-", $row["user_birth_date"]);
		$event_time = mktime(0,0,0, $birth_date[1], $birth_date[2], date("Y"));
		if($event_time < time()) 
			$event_time = mktime(0,0,0, $birth_date[1], $birth_date[2], date("Y")+1);
		$event_datetime = date("Y-m-d H:i:s", $event_time);
		$event_date = date("Y-m-d", $event_time);
		$event_expire = $event_time+36000;

		$events_cat = $cfg["plugin"]["birthdays"]["birthday_events_category"];

		if(!is_dir($plugin_templates."/events/".$row["user_gender"])) $row["user_gender"] = "U"; // default to Unspecified..
		$templates_dir = $plugin_templates."/events/".$row["user_gender"];

		$templates_title = Array();
		if($dir = opendir($templates_dir."/title"))
		{
			while($file = readdir($dir))
			{
				if($file{0} == ".") continue;
				$templates_title[] = $file;
			}
			closedir($dir);
		}
		if(count($templates_title))
			$event_title = file_get_contents($templates_dir."/title/".$templates_title[array_rand($templates_title)]);
		else $event_title = "%user's birthday";

		$templates_text = Array();
		if($dir = opendir($templates_dir."/text"))
		{
			while($file = readdir($dir))
			{
				if($file{0} == ".") continue;
				$templates_text[] = $file;
			}
			closedir($dir);
		}
		if(count($templates_text))
			$event_text = file_get_contents($templates_dir."/text/".$templates_text[array_rand($templates_text)]);
		else $event_text = "Happy birthday, %user!";

		$event_title = $plx_sql_prep(strtr($event_title, Array(
				"%user" => $row["user_name"],
				"%level" => $row["user_level"],
				"%site" => $cfg["maintitle"],
				)));

		$event_text = $plx_sql_prep(strtr($event_text, Array(
				"%user" => $row["user_name"],
				"%level" => $row["user_level"],
				"%site" => $cfg["maintitle"],
				)));

		$sql = <<<SQL
INSERT INTO `{$db_events}`
	SET `event_cat`='{$events_cat}',
		`{$event_owner_fieldname}`='{$event_owner_fieldvalue}',
		`event_date`='{$event_time}',
		`event_expire`='{$event_expire}',
		`event_title`='{$event_title}',
		`event_text`='{$event_text}'
SQL;
		$plx_sql_query($sql);
		$event_id = $plx_sql_insertid();
		$sql = <<<SQL
UPDATE `{$db_plugin}`
	SET `event_id`='{$event_id}',
		`event_time`='{$event_datetime}'
	WHERE `user_id`='{$row["user_id"]}'
SQL;
		$plx_sql_query($sql);
	}
	$plx_sql_freeresult($res);

	return true;
}

function birthdays_update_news()
{
	global $sys, $cfg, $_PLUGINLIB;
	global $db_users, $db_groups, $db_plugin, $db_news, $plugin_templates;
	global $plx_sql_query, $plx_sql_numrows, $plx_sql_fetchassoc, $plx_sql_freeresult, $plx_sql_prep, $plx_sql_insertid;

	if(!$cfg['plugin']['birthdays']['birthday_news'] || empty($db_news)) return false;

	$engine = $_PLUGINLIB["engine"];
	switch($engine)
	{
		case "sed":
			$sql = <<<SQL
SELECT u.user_id, u.user_name, u.user_gender, g.grp_level AS user_level, b.user_birth_date, b.news_id, b.news_time
	FROM `{$db_users}` u
		INNER JOIN `{$db_plugin}` b USING(user_id)
		INNER JOIN `{$db_groups}` g ON (u.user_maingrp=g.grp_id)
	WHERE g.grp_level>='{$cfg["plugin"]["birthdays"]["birthday_news_minlevel"]}'
		AND u.user_birthdate!=0
		AND MONTH(b.user_birth_date)=MONTH(NOW())
		AND DAYOFMONTH(b.user_birth_date)=DAYOFMONTH(NOW())
		AND DATE(b.news_time)<DATE(NOW())
SQL;
			break;
		case "ldu":
			$sql = <<<SQL
SELECT u.user_id, u.user_name, u.user_gender, u.user_level, b.user_birth_date, b.news_id, b.news_time
	FROM `{$db_users}` u
		INNER JOIN `{$db_plugin}` b USING(user_id)
	WHERE u.user_level>='{$cfg["plugin"]["birthdays"]["birthday_news_minlevel"]}'
		AND u.user_birthdate!=0
		AND MONTH(b.user_birth_date)=MONTH(NOW())
		AND DAYOFMONTH(b.user_birth_date)=DAYOFMONTH(NOW())
		AND DATE(b.news_time)<DATE(NOW())
SQL;
			break;
		default:
			return false;
	}
	$res = $plx_sql_query($sql);
	while($row = $plx_sql_fetchassoc($res))
	{
		$user_gender = strcasecmp($row["user_gender"],"F")?"m":"f";
		$news_user_id = $row["user_id"];
		$news_user_name = $plx_sql_prep($row["user_name"]);

		$news_date = mktime(0,0,0, date("m"), date("d"), date("Y"));
		$news_datetime = date("Y-m-d 00:00:00");
		$news_cat = $cfg["plugin"]["birthdays"]["birthday_news_category"];

		if(!is_dir($plugin_templates."/news/".$row["user_gender"])) $row["user_gender"] = "U"; // default to Unspecified..
		$templates_dir = $plugin_templates."/news/".$row["user_gender"];

		$templates_title = Array();
		if($dir = opendir($templates_dir."/title"))
		{
			while($file = readdir($dir))
			{
				if($file{0} == ".") continue;
				$templates_title[] = $file;
			}
			closedir($dir);
		}
		if(count($templates_title))
			$news_title = file_get_contents($templates_dir."/title/".$templates_title[array_rand($templates_title)]);
		else $news_title = "%user's birthday";

		$templates_text = Array();
		if($dir = opendir($templates_dir."/text"))
		{
			while($file = readdir($dir))
			{
				if($file{0} == ".") continue;
				$templates_text[] = $file;
			}
			closedir($dir);
		}
		if(count($templates_text))
			$news_text = file_get_contents($templates_dir."/text/".$templates_text[array_rand($templates_text)]);
		else $news_text = "Happy birthday, %user!";

		$news_title = $plx_sql_prep(strtr($news_title, Array(
				"%user" => $row["user_name"],
				"%level" => $row["user_level"],
				"%site" => $cfg["maintitle"],
				)));

		$news_text = $plx_sql_prep(strtr($news_text, Array(
				"%user" => $row["user_name"],
				"%level" => $row["user_level"],
				"%site" => $cfg["maintitle"],
				)));


		switch($engine)
		{
			case "sed":
				$sql = <<<SQL
INSERT INTO `{$db_news}`
	SET `page_cat`='{$news_cat}',
		`page_date`='{$news_date}',
		`page_author`='{$news_user_name}',
		`page_ownerid`='{$news_user_id}',
		`page_title`='{$news_title}',
		`page_text`='{$news_text}'
SQL;
				break;
			case "ldu":
				$sql = <<<SQL
INSERT INTO `{$db_news}`
	SET `news_cat`='{$news_cat}',
		`news_date`='{$news_date}',
		`news_owner`='{$news_user_name}',
		`news_ownerid`='{$news_user_id}',
		`news_title`='{$news_title}',
		`news_text`='{$news_text}'
SQL;
				break;
		}
		$plx_sql_query($sql);

		$news_id = $plx_sql_insertid();

		$sql = <<<SQL
UPDATE `{$db_plugin}`
	SET `news_id`='{$news_id}',
		`news_time`=NOW()
	WHERE `user_id`='{$news_user_id}'
SQL;
		$plx_sql_query($sql);
	}
	$plx_sql_freeresult($res);

	return true;
}

function birthdays_today()
{
	global $sys, $db_users, $db_plugin;
	global $plx_sql_query, $plx_sql_fetchassoc, $plx_sql_freeresult;
	global $plx_cache_get, $plx_cache_store;

	if( ($birthdays_today = $plx_cache_get("birthdays_today")) === false)
	{
		$sql = <<<SQL
SELECT u.*, b.user_birth_date AS birthday_date, MONTH(b.user_birth_date) AS birthday_month, DAYOFMONTH(b.user_birth_date) AS birthday_day
	FROM `{$db_users}` u
		INNER JOIN `{$db_plugin}` b USING(user_id)
	WHERE MONTH(b.user_birth_date)=MONTH(NOW())
		AND DAYOFMONTH(b.user_birth_date)=DAYOFMONTH(NOW())
	ORDER BY u.user_name
SQL;
		$res = $plx_sql_query($sql);
		$birthdays_today = Array();
		while($row = $plx_sql_fetchassoc($res)) $birthdays_today[] = $row;
		$plx_sql_freeresult($res);

		$expire = strtotime(date('Y-m-d 00:00:00'))+86400-$sys['now']; // expiry should happen at 00:00
		$plx_cache_store("birthdays_today",$birthdays_today,$expire,0);
	}
	return $birthdays_today;
}

?>
